routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/', function () {
    return view('pages.home');
});
Route::get('information', function () {
    return view('pages.information');
});
Route::get('contact', function () {
    return view('pages.contact');
});
Route::post('contact', 'HomepageController@postContact');

Route::group([
    'prefix' => 'signup',
    'namespace' => 'Learner'
], function () {
    Route::get('/', 'SignupController@getList');
    Route::post('/', 'SignupController@postList');

    Route::get('auth', 'SignupController@getAuth');
    Route::post('auth', 'SignupController@postAuth');

    Route::get('form', function () {
        $month = date('m');
        return redirect('signup/form/'.$month);
    });
    Route::get('form/{month}', 'SignupController@getForm');
    Route::post('form', 'SignupController@postForm');

    Route::get('month/{month}', 'SignupController@getMonth');

    Route::get('complete', 'SignupController@getComplete');
});

Route::group([
    'prefix' => 'learner',
    'middleware' => 'auth:learner',
    'namespace' => 'Learner'
], function () {
    Route::get('/', 'OverviewController@getIndex');
    Route::get('calendar', 'OverviewController@getCalendar');
    Route::get('invoices', 'OverviewController@getInvoices');

    Route::get('details', 'OverviewController@getDetails');
    Route::post('details', 'OverviewController@postDetails');
});

Route::get('invoice/{invoice_code}/{invoice_hash}', 'InvoiceController@getInvoice');

Route::group([
    'prefix' => 'instructor',
    'middleware' => 'auth:instructor',
    'namespace' => 'Instructor'
], function () {
    Route::get('/', 'OverviewController@getIndex');
    Route::get('calendar', 'OverviewController@getCalendar');
    Route::get('course/{course}', 'OverviewController@getCourse');
    Route::get('details', 'OverviewController@getDetails');
    Route::post('details', 'OverviewController@postDetails');
});

Route::get('login', function () {
    return redirect('auth/login');
});

Route::group([
    'prefix' => 'auth',
    'namespace' => 'Auth'
], function () {
    Route::get('login', 'LoginController@getLogin');
    Route::get('logout', 'LoginController@getLogout');
    Route::post('login', 'LoginController@postLogin');
});

Auth::routes();

app/Models/Invoice.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * App\Models\Invoice
 *
 * @property integer $id
 * @property \Carbon\Carbon $created_at
 * @property \Carbon\Carbon $updated_at
 * @property \Carbon\Carbon $deleted_at
 * @property integer $learner_id
 * @property integer $course_id
 * @property integer $status
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\InvoiceLine[] $lines
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereId($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereCreatedAt($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereUpdatedAt($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereDeletedAt($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereLearnerId($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereCourseId($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereStatus($value)
 * @mixin \Eloquent
 * @property string $file_name
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereFileName($value)
 * @property string $invoice_code
 * @property string $invoice_hash
 * @property-read \App\Models\Learner $learner
 * @property-read mixed $total
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereInvoiceCode($value)
 * @method static \Illuminate\Database\Query\Builder|\App\Models\Invoice whereInvoiceHash($value)
 */
class Invoice extends Model
{

    private $statuses = [
        0 => 'Openstaand',
        1 => 'Voldaan',
        2 => 'Geannuleerd'
    ];

    protected $table = 'invoices';
    public $timestamps = true;

    use SoftDeletes;

    protected $dates = ['deleted_at'];
    protected $fillable = ['learner_id', 'course_id', 'status'];

    public function getStatusStringAttribute()
    {
        if (isset($this->statuses[$this->status])) {
            return $this->statuses[$this->status];
        }
        return $this->status;
    }

    public function getUrlAttribute()
    {
        return url('invoice/' . $this->invoice_code . '/' . $this->invoice_hash);
    }

    public function lines()
    {
        return $this->hasMany('App\Models\InvoiceLine', 'invoice_id', 'id');
    }

    public function learner()
    {
        return $this->hasOne('App\Models\Learner', 'id', 'learner_id');
    }

    public function getTotalAttribute()
    {
        $total = 0;
        foreach ($this->lines as $item) {
            $total += $item->price;
        }
        return $total;
    }
}

app/Http/Controllers/Learner/OverviewController.php
<?php

namespace App\Http\Controllers\Learner;

use Auth;
use App\Http\Controllers\Controller;
use App\Models\Learner;
use Carbon\Carbon;
use Illuminate\Http\Request;

class OverviewController extends Controller
{
    public function getIndex()
    {
        return redirect('learner/calendar');
    }

    public function getCalendar()
    {
        $user = Auth::guard('learner')->user();
        $courses = $user->courses()->where('date_start', '>', Carbon::now())->get();

        $events = [];
        foreach ($courses as $cou) {
            $events[] = [
                "title" => $cou->name,
                "start" => date('Y-m-d', strtotime($cou->date_start)) . " 13:00",
                "end" => $cou->date_end,
                "data" => [
                    "name" => $cou->name,
                    "type" => $cou->type->name,
                    "date_range" => $cou->date_range
                ]
            ];
        }

        return view('learner.calendar', ['courses' => $courses, 'events' => $events]);
    }

    public function getInvoices()
    {
        $user = Auth::guard('learner')->user();
        $invoices = $user->invoices()->orderBy('created_at', 'DESC')->get();
        return view('learner.invoices', ['invoices' => $invoices]);
    }

    public function getDetails()
    {
        $user = Auth::guard('learner')->user();
        return view('learner.details', ['user' => $user]);
    }

    public function postDetails(Request $request)
    {
        $checks = [
            "name_first" => "required",
            "name_last" => "required",
            "email" => "required|email",

            "address_street" => "required",
            "address_number" => "required",
            "address_city" => "required",
            "address_postcode" => "required",
            "country" => "required",

            "phonenumber" => "required",
            "birthdate" => "required|date_format:\"d-m-Y\""
        ];
        if ($request->input('password')) {
            $checks["password"] = "required|confirmed";
        }
        $this->validate($request, $checks);

        $user = Auth::guard('learner')->user();
        $user->name_first = $request->input('name_first');
        $user->name_last = $request->input('name_last');
        $user->email = $request->input('email');
        if ($request->input('password')) {
            $user->password = bcrypt($request->input('password'));
        }
        $user->address_street = $request->input('address_street');
        $user->address_number = $request->input('address_number');
        $user->address_postcode = $request->input('address_postcode');
        $user->address_city = $request->input('address_city');
        $user->country = $request->input('country');
        $user->phonenumber = $request->input('phonenumber');
        $user->birthdate = strtotime($request->input('birthdate'));
        $user->save();

        return redirect('learner/details')->with('message', 'De gegevens zijn aangepast.');
    }
}

app/Http/Controllers/Learner/SignupController.php
<?php

namespace App\Http\Controllers\Learner;

use App\Jobs\LearnerSignupJob;
use App\Models\CourseLearnerAssignment;
use App\Models\CourseType;
use App\Models\Course;
use Auth;
use App\Models\Learner;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SignupController extends Controller
{
    public function getList()
    {
        $types = CourseType::where('active', 1)->get();
        $num = 0;
        $table = 0;
        $tables = [];
        foreach ($types as $ty) {
            if($num == 0) {
                $tables[$table] = [
                    'ids' => [],
                    'headers' => [],
                    'ships' => [],
                    'prices' => [],
                    'ages' => [],
                    'sleep_food' => []
                ];
            }
            $tables[$table]['ids'][] = $ty->id;
            $tables[$table]['headers'][] = $ty->name;
            $tables[$table]['ships'][] = $ty->ship->name;
            $tables[$table]['prices'][] = $ty->price;
            if ($ty->min_age == null) {
                $tables[$table]['ages'][] = "geen minimale leeftijd";
            } else {
                $tables[$table]['ages'][] = "vanaf " . $ty->min_age . " jaar";
            }
            if ($ty->sleep_food_included) {
                $tables[$table]['sleep_food'][] = "Ja";
            } else {
                $tables[$table]['sleep_food'][] = "Nee";
            }
            $num++;
            if($num == 4) {
                $table++;
                $num = 0;
            }
        }
        return view('signup.course_list', [
            'tables' => $tables
        ]);
    }

    public function postList(Request $request)
    {
        \Session::set('type', $request->input('course_id'));
        return redirect('signup/auth');
    }

    public function getAuth()
    {
        if (session('user')) {
            return redirect('signup/form');
        }
        $course_type = CourseType::find(session('type'));
        return view('signup.auth', ['type' => $course_type]);
    }

    public function postAuth(Request $request)
    {
        $action = $request->input('action');
        if ($action == 'login') {
            $learner = Auth::guard('learner')->attempt([
                'email' => $request->input('email'),
                'password' => $request->input('password')
            ]);
            if ($learner) {
                \Session::set('user', Auth::guard('learner')->user());
                return redirect('signup/form');
            }
            return redirect('signup/auth')->with('error', 'Deze inloggegevens zijn incorrect');
        } elseif ($action == 'register') {
            $checks = [
                "name_first" => "required",
                "name_last" => "required",
                "email" => "required|email",
                "password" => "required|confirmed",

                "address_street" => "required",
                "address_number" => "required",
                "address_city" => "required",
                "address_postcode" => "required",
                "address_country" => "required",

                "phonenumber" => "required",
                "birthdate" => "required|date_format:\"d-m-Y\""
            ];
            $this->validate($request, $checks);

            $user = new Learner();
            $user->name_first = $request->input('name_first');
            $user->name_last = $request->input('name_last');
            $user->email = $request->input('email');
            $user->password = bcrypt($request->input('password'));
            $user->address_street = $request->input('address_street');
            $user->address_number = $request->input('address_number');
            $user->address_postcode = $request->input('address_postcode');
            $user->address_city = $request->input('address_city');
            $user->country = $request->input('address_country');
            $user->phonenumber = $request->input('phonenumber');
            $user->birthdate = strtotime($request->input('birthdate'));
            $user->save();

            $learner = Auth::guard('learner')->attempt([
                'email' => $request->input('email'),
                'password' => $request->input('password')
            ]);
            if ($learner) {
                \Session::set('user', Auth::guard('learner')->user());
                return redirect('signup/form');
            }
        }

        return redirect('signup/auth')->with('error', 'Er is iets mis gegaan, probeer het opnieuw');
    }

    public function getForm($month)
    {
        $this->middleware('auth:learner');
        $type_id = session('type');
        if (!$type_id) {
            return redirect('signup')->with('error', 'De sessie is verlopen, probeer het opnieuw.');
        }
        $type = CourseType::find($type_id);
        $courses = Course::where(function ($query) use ($type_id, $month) {
            $query->where('type_id', $type_id);
            $query->where('date_start', '>', Carbon::now());
            $query->where('date_start', '>=', Carbon::createFromDate(date('Y'), $month, 1));
            $query->where('date_start', '<', Carbon::createFromDate(date('Y'), $month + 1, 1));
        })->orderBy('date_start')->get();
        return view('signup.form', ['courses' => $courses, 'type' => $type]);
    }

    public function postForm(Request $request)
    {
        $this->middleware('auth:learner');
        $checks = [
            "course" => "required|exists:courses,id",
            "accept_av" => "accepted"
        ];
        $this->validate($request, $checks);

        $user = Auth::guard('learner')->user();
        $course = Course::find($request->input('course'));
        $job = new LearnerSignupJob($user, $course);
        $this->dispatch($job);

        return redirect('signup/complete')->with('completed', true);
    }

    public function getComplete()
    {
        if (!session('completed')) {
            return redirect('signup')->with('error', 'De sessie is verlopen, probeer het opnieuw.');
        }
        return view('signup.complete');
    }
}

resources/views/learner/calendar.blade.php
@extends('learner.layout')

@section('learner-content')
    <h2>Agenda</h2>
    <ul class="nav nav-tabs">
    <li class="active"><a data-toggle="tab" href="#home">Agenda</a></li>
    <li><a data-toggle="tab" href="#menu1">Tabel</a></li>
  </ul>
<div class="tab-content">
    <div id="home" class="tab-pane fade in active">
      <div id='calendar'></div>
    </div>
    <div id="menu1" class="tab-pane fade">
      <table class="table">
        <thead>
        <tr>
            <th>Soort Cursus</th>
            <th>Naam</th>
            <th>Datum</th>
        </tr>
        </thead>
        <tbody>
      @foreach($courses as $cou)
        <tr>
          <td>{{ $cou->type->name }}</td>
          <td>{{ $cou->name }}</td>
          <td>{{ $cou->date_range }}</td>         
      </tr>
      @endforeach
        </tbody>
    </table>
    </div>
</div>
@endsection

@section('page-head')
    <link rel="stylesheet" type="text/css"
          href="https://cdnjs.cloudflare.com/ajax/libs/fullcalendar/3.1.0/fullcalendar.min.css">
@endsection
@section('page-scripts')
    <div class="modal fade" id="course-modal" tabindex="-1" role="dialog" aria-labelledby="course-modal">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="course-name">course-name</h4>
                </div>
                <div class="modal-body">
                    Deze cursus is van <span id="course-range">course-range</span> en begint om 13:00 uur.
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Sluiten</button>
                </div>
            </div>
        </div>
    </div>

    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/fullcalendar/3.1.0/fullcalendar.min.js"></script>

    <script type="text/javascript">
        $(document).ready(function () {
            $('#calendar').fullCalendar({
                events: {!! json_encode($events) !!},
                eventClick: function (event) {
                    $('#course-name').text(event.data.type + " - " + event.data.name);
                    $('#course-range').text(event.data.date_range);
                    $('#course-modal').modal('show');
                }
            });
        });
    </script>
@endsection

resources/views/learner/details.blade.php
@extends('learner.layout')

@section('learner-content')
    <h2>Mijn gegevens</h2>
    @if (count($errors) > 0)
        <div class="alert alert-danger">
            <ul class="list-unstyled">
                @foreach ($errors->all() as $error)
                    <li>- {{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif
    @if(session('message'))
        <div class="alert alert-success">
            {{ session('message') }}
        </div>
    @endif
    <form method="POST" action="{{ url('learner/details') }}">
        {!! csrf_field() !!}
        <input type="hidden" name="action" value="register">
        <div class="row">
            <div class="col-md-5">
                <label for="name_first">Voornaam:</label>
                <input type="text" name="name_first" id="name_first" class="form-control"
                       placeholder="Jan" value="{{ old('name_first', $user->name_first) }}">
            </div>
            <div class="col-md-7">
                <label for="name_last">Achternaam:</label>
                <input type="text" name="name_last" id="name_last" class="form-control"
                       placeholder="Jansen" value="{{ old('name_last', $user->name_last) }}">
            </div>
        </div>
        <br/>
        <div class="row">
            <div class="col-md-12">
                <label for="email">E-mail adres:</label>
                <input type="text" name="email" id="email" class="form-control"
                       placeholder="jan@jansen.nl" value="{{ old('email', $user->email) }}">
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <label for="password">Wachtwoord:</label>
                <input type="password" name="password" id="password" class="form-control"
                       placeholder="Wachtwoord">
            </div>
            <div class="col-md-6">
                <label for="password_confirmation">Wachtwoord confirmatie:</label>
                <input type="password" name="password_confirmation" id="password_confirmation"
                       class="form-control"
                       placeholder="Wachtwoord">
            </div>
        </div>
        <br/>
        <div class="row">
            <div class="col-md-8">
                <label for="address_street">Straat:</label>
                <input type="text" name="address_street" id="address_street" class="form-control"
                       placeholder="Jansweg" value="{{ old('address_street', $user->address_street) }}">
            </div>
            <div class="col-md-4">
                <label for="address_number">Huisnummer:</label>
                <input type="text" name="address_number" id="address_number" class="form-control"
                       placeholder="42" value="{{ old('address_number', $user->address_number) }}">
            </div>
        </div>
        <div class="row">
            <div class="col-md-8">
                <label for="address_city">Woonplaats:</label>
                <input type="text" name="address_city" id="address_city" class="form-control"
                       placeholder="Amsterdam" value="{{ old('address_city', $user->address_city) }}">
            </div>
            <div class="col-md-4">
                <label for="address_postcode">Postcode:</label>
                <input type="text" name="address_postcode" id="address_postcode" class="form-control"
                       placeholder="6811 AA" value="{{ old('address_postcode', $user->address_postcode) }}">
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <label for="country">Land:</label>
                <input type="text" name="country" id="country" class="form-control"
                       value="{{ old('country', $user->country) }}">
            </div>
            <div class="col-md-6">
                <label for="phonenumber">Telefoonnummer:</label>
                <input type="text" name="phonenumber" id="phonenumber" class="form-control"
                       placeholder="06-32109876" value="{{ old('phonenumber', $user->phonenumber) }}">
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <label for="birthdate">Geboortedatum (dd-mm-yyyy):</label>
                <input type="text" name="birthdate" id="birthdate" class="form-control"
                       placeholder="28-01-2001"
                       value="{{ old('birthdate', date('d-m-Y', $user->birthdate->getTimestamp())) }}">
            </div>
        </div>
        <br/>
        <input type="submit" class="btn btn-primary pull-right" value="Aanpassen">
    </form>
@endsection

resources/views/learner/invoices.blade.php
@extends('learner.layout')

@section('learner-content')
    <h2>Facturen</h2>
    <table class="table">
        <thead>
        <tr>
            <th>#</th>
            <th>Factuurdatum</th>
            <th>Status</th>
            <th>Bekijken</th>
        </tr>
        </thead>
        <tbody>
        @foreach($invoices as $invoice)
            <tr>
                <td>#{{ $invoice->id }}</td>
                <td>{{ date('d-m-Y', $invoice->created_at->getTimeStamp()) }}</td>
                <td>{{ $invoice->status_string }}</td>
                <td><a href="{{ $invoice->url }}" target="_blank">Bekijken</a></td>
            </tr>
        @endforeach
        </tbody>
    </table>
@endsection

resources/views/learner/layout.blade.php
@extends('layout')

@section('page-title', 'Mijn Account -')
@section('page-content')
    <div class="information">
        <div class="col-md-3">
            <h5>
                {{ session('user.name_full') }}
                <small><a href="{{ url('/auth/logout') }}" class="pull-right">Uitloggen</a></small>
            </h5>
            <ul class="list-group">
                <li class="list-group-item">
                    <a href="{{ url('/learner/details') }}">Mijn gegevens</a>
                </li>
                <li class="list-group-item">
                    <a href="{{ url('/learner/calendar') }}">Agenda</a>
                </li>
                <li class="list-group-item">
                    <a href="{{ url('/learner/invoices') }}">Facturen</a>
                </li>
            </ul>
        </div>
        <div class="col-md-9">
            @yield('learner-content')
        </div>
    </div>
@endsection